<template>
  <section class="partsCatalogs">
    <AppAccordion :accordion-mobile="true">
      <div slot="panel-title">
        Каталоги запчастей
      </div>
      <template #content>
        <div class="partsCatalogs-wrapper">
          <div class="partsCatalogs-item _type-car">
            <AppAccordion
              :accordion-mobile="true"
              class="_transparent">
              <template #panel-title>
                <div class="partsCatalogs-title">
                  <flink
                    href="/catalog"
                    domain="main"
                    class="link">
                    <span class="button-item">
                      По автомобилям
                    </span>
                  </flink>
                </div>
              </template>
              <template #content>
                <div class="partsCatalogs-content">
                  <flink
                    href="/catalog/oem"
                    class="partsCatalogs-catalog __box-blue">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/home-origin-image.svg">
                    <div class="partsCatalogs-name">
                      Оригинальные каталоги
                    </div>
                  </flink>
                  <flink
                    href="/catalog/am"
                    class="partsCatalogs-catalog __box-gray">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/home-analog-image.svg">
                    <div class="partsCatalogs-name">
                      Каталоги заменителей
                    </div>
                  </flink>
                </div>
              </template>
            </AppAccordion>
            <flink
              href="/catalog"
              domain="main"
              class="button buttonLight">
              <span class="button-item">
                Все каталоги
                <img
                  svg-inline
                  src="~/assets/svg/redesign/button-arrow-right.svg">
              </span>
            </flink>
          </div>

          <div class="partsCatalogs-item _type-part">
            <AppAccordion
              :accordion-mobile="true"
              class="_transparent">
              <div
                slot="panel-title"
                class="partsCatalogs-title">
                <flink
                  domain="main"
                  href="/categories"
                  class="link">
                  <span class="button-item">
                    По виду запчасти
                  </span>
                </flink>
              </div>
              <template #content>
                <div class="partsCatalogs-content _column">
                  <template v-for="group in popularPartGroups">
                    <ul
                      v-for="subgroup in group.subgroups"
                      :key="subgroup.id"
                      class="partsCatalogs-group _break-avoid">
                      <li class="partsCatalogs-group-item _title">
                        <flink
                          domain="main"
                          :href="`/categories/${group.slug}/${subgroup.slug}`"
                          class="link">
                          {{ subgroup.name }}
                        </flink>
                        <ul class="partsCatalogs-group _break-avoid">
                          <li
                            v-for="partName in subgroup.partnames"
                            :key="partName.id"
                            class="partsCatalogs-group-item _break-avoid">
                            <flink
                              domain="main"
                              :href="`/categories/${group.slug}/${subgroup.slug}/${partName.slug}`"
                              class="link linkDark">
                              {{ partName.name }}
                            </flink>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </template>
                </div>
              </template>
            </AppAccordion>
            <flink
              domain="main"
              href="/categories"
              class="button buttonLight">
              <span class="button-item">
                Все запчасти
                <img
                  svg-inline
                  src="~/assets/svg/redesign/button-arrow-right.svg">
              </span>
            </flink>
          </div>
        </div>
      </template>
    </AppAccordion>
  </section>
</template>

<script>
import { mapState } from 'vuex';

import AppAccordion from '~/components/redesign/app-accordion';

export default {
  name: 'PartsCatalogs',
  components: {
    AppAccordion,
  },
  computed: {
    ...mapState(['popularPartGroups']),
  },
};
</script>

<style lang="postcss">
  .partsCatalogs {
    @media screen and (min-width: 981px) {
      position: absolute;
      z-index: 3;
      top: calc(100% + 1px);
      left: 3.375rem;
      right: 3.375rem;
      display: flex;
      justify-content: space-between;
      padding: 1.5rem 0 1.875rem 0;
      max-height: 27.5rem;
      cursor: default;

      background-color: var(--bg-main);
      border-bottom-left-radius: 0.25rem;
      border-bottom-right-radius: 0.25rem;
      box-shadow: 0 3px 3px rgba(0, 0, 0, 0.1);

      &-wrapper {
        display: flex;
        justify-content: center;
        margin: 0 auto;
        width: 100%;
        max-width: 83.875rem;
      }

      &-item {
        position: relative;
        display: inline-flex;
        flex-direction: column;
        text-align: left;

        &:first-child:after {
          content: '';
          position: absolute;
          right: 0;
          top: 0;
          bottom: 3.75rem;
          width: 1px;
          background-color: var(--color-disabled);
        }

        &._type-car {
          flex-shrink: 0;
          padding-right: 3.25rem;
          padding-left: 2.5rem;
          width: 30rem;
        }

        &._type-part {
          width: 100%;
          padding-left: 3.25rem;
          padding-right: 2.5rem;
        }

        .accordion {
          height: 100%;
        }

        .accordion-title {
          display: block;

          > .svg {
            display: none;
          }
        }

        & > .button.buttonLight {
          background-color: var(--bg-dark);
        }
      }

      &-title {
        display: block;
        padding-bottom: 1rem;
        font-size: 0.75rem;
        font-weight: var(--font-weight-regular);
        line-height: 1.4;
        color: var(--color-main-lightest);
        text-transform: uppercase;
      }

      &-content {
        display: block;
        margin-bottom: 0.5rem;
        height: 100%;
        max-height: 20rem;

        &._column {
          overflow: hidden;
          column-gap: 4%;
          column-count: 4;
          column-width: 12rem;
          column-fill: balance;
        }
      }

      &-group {
        display: block;
        padding: 0;
        margin: 0;
        list-style: none;

        &-item {
          display: block;
          padding: 0.375rem 0;
          font-size: 0.75rem;
          font-weight: var(--font-weight-regular);
          line-height: 1.2;
          white-space: normal;

          &._title {
            font-weight: var(--font-weight-medium);
            line-height: 1.4;
          }
        }
      }

      ._break-avoid {
        page-break-inside: avoid;
        break-inside: avoid-column;
      }

      &-group + &-group {
        margin-top: 0.875rem;
      }

      &-catalog {
        display: flex;
        justify-content: center;
        align-items: center;
        margin-bottom: 1.5rem;
        padding: 1rem;
        width: 100%;
        height: 7rem;
        color: var(--color-main);
        transition: color 0.3s var(--transition-easeOutQuad);

        > .svg {
          flex-shrink: 0;
          width: 4.375rem;
          height: auto;
        }

        &:hover, &:active, &:focus {
          color: var(--link-dark-hover-color);
        }
      }

      &-name {
        display: block;
        padding-left: 1.5rem;
        width: 17.5rem;
        font-size: 1.25rem;
        font-weight: var(--font-weight-medium);
      }
    }

    @media (max-width: 1200px) and (min-width: 981px) {
      &-item._type-car {
        width: 28rem;
      }

      &-name {
        width: 13.5rem;
        font-size: 1rem;
      }
    }

    @media screen and (max-width: 980px) {
      padding: 0;

      &-wrapper {
        display: block;
        width: 100%;

        &.container {
          padding: 0;
        }
      }

      &-item {
        .button.buttonLight {
          display: none;
        }
        .accordion {
          height: auto;
        }
      }

      &-title {
        display: block;
        font-size: 1rem;
        font-weight: var(--font-weight-medium);
        color: var(--link-color);

        + .svg {
          fill: var(--link-color);
        }
      }

      &-content {
        display: block;
        width: 100%;
      }

      &-group-item > .link {
        display: block;
        padding: 0.875rem 0 0.875rem 1.25rem;
        width: 100%;
        font-size: 1rem;
        color: var(--color-main);
      }

      &-group-item > &-group {
        display: none;
      }

      .accordion {
        &-panel {
          border-bottom: 1px solid var(--border-color-main);
        }

        &-title {
          padding-top: 1.375rem;
          padding-bottom: 1.375rem;
          padding-left: 1.25rem;
          width: 100%;
          font-size: 1.125rem;
          font-weight: var(--font-weight-medium);
          background-color: var(--bg-lightest);
        }

        &-content {
          padding: 0 0 0 0.875rem;
        }

        &._transparent {
          .accordion-panel {
            border-bottom: none;
          }

          .accordion-title {
            background-color: transparent;
          }
        }
      }
    }
  }
</style>
